Index: able/HeuristicLab.Tests/HeuristicLab.PluginInfraStructure-3.3/InstallationManagerTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.PluginInfraStructure-3.3/InstallationManagerTest.cs	(revision 15390)
+++ 	(revision )
@@ -1,67 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using HeuristicLab.PluginInfrastructure.Advanced;
-using Microsoft.VisualStudio.TestTools.UnitTesting;
-
-namespace HeuristicLab.PluginInfrastructure.Tests {
-  /// <summary>
-  ///This is a test class for InstallationManagerTest and is intended
-  ///to contain all InstallationManagerTest Unit Tests
-  ///</summary>
-  [TestClass()]
-  public class InstallationManagerTest {
-    /// <summary>
-    ///A test for GetRemotePluginList
-    ///</summary>
-    [TestMethod]
-    [TestCategory("General")]
-    [TestProperty("Time", "long")]
-    public void GetRemotePluginListTest() {
-      string pluginDir = Environment.CurrentDirectory;
-      try {
-        InstallationManager target = new InstallationManager(pluginDir);
-        var pluginList = target.GetRemotePluginList();
-        Assert.IsTrue(pluginList != null);
-      } catch (Exception e) {
-        Assert.Fail("Connection to the update service failed. " + e.Message);
-      }
-    }
-
-    /// <summary>
-    ///A test for GetRemoteProductList
-    ///</summary>
-    [TestMethod]
-    [TestCategory("General")]
-    [TestProperty("Time", "short")]
-    public void GetRemoteProductListTest() {
-      string pluginDir = Environment.CurrentDirectory;
-      try {
-        InstallationManager target = new InstallationManager(pluginDir);
-        var productList = target.GetRemoteProductList();
-        Assert.IsTrue(productList != null);
-      } catch (Exception e) {
-        Assert.Fail("Connection to the update service failed. " + e.Message);
-      }
-    }
-  }
-}
Index: /stable/HeuristicLab.Tests/HeuristicLab.Tests.csproj
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 15390)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 15391)
@@ -581,5 +581,4 @@
     <Compile Include="HeuristicLab.Persistence-3.3\StorableAttributeTests.cs" />
     <Compile Include="HeuristicLab.Persistence-3.3\UseCases.cs" />
-    <Compile Include="HeuristicLab.PluginInfraStructure-3.3\InstallationManagerTest.cs" />
     <Compile Include="HeuristicLab.PluginInfraStructure-3.3\TypeExtensionsTest.cs" />
     <Compile Include="HeuristicLab.Problems.DataAnalysis-3.4\ThresholdCalculatorsTest.cs" />
Index: /stable/HeuristicLab.Tests/app.config
===================================================================
--- /stable/HeuristicLab.Tests/app.config	(revision 15390)
+++ /stable/HeuristicLab.Tests/app.config	(revision 15391)
@@ -1,65 +1,6 @@
 <?xml version="1.0" encoding="utf-8"?>
 <configuration>
-  <configSections>
-    <sectionGroup name="userSettings" type="System.Configuration.UserSettingsGroup, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
-      <section name="HeuristicLab.PluginInfrastructure.Properties.Settings" type="System.Configuration.ClientSettingsSection, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" allowExeDefinition="MachineToLocalUser" requirePermission="false"/>
-    </sectionGroup>
-  </configSections>
-
-  <userSettings>
-    <HeuristicLab.PluginInfrastructure.Properties.Settings>
-      <setting name="UpdateLocationUserName" serializeAs="String">
-        <value>anonymous</value>
-      </setting>
-      <setting name="UpdateLocationPassword" serializeAs="String">
-        <value>GetTheLab!</value>
-      </setting>
-      <setting name="ShowPluginUploadControls" serializeAs="String">
-        <value>False</value>
-      </setting>
-      <setting name="UpdateLocation" serializeAs="String">
-        <value>http://services.heuristiclab.com/Deployment-3.3/UpdateService.svc</value>
-      </setting>
-      <setting name="UpdateLocationAdministrationAddress" serializeAs="String">
-        <value>http://services.heuristiclab.com/Deployment-3.3/AdminService.svc</value>
-      </setting>
-    </HeuristicLab.PluginInfrastructure.Properties.Settings>
-  </userSettings>
-
-  <system.serviceModel>
-    <bindings>
-      <wsHttpBinding>
-        <binding name="WSHttpBinding_IUpdateService" closeTimeout="00:01:00" openTimeout="00:01:00" receiveTimeout="00:10:00" sendTimeout="00:01:00" bypassProxyOnLocal="false" transactionFlow="false" hostNameComparisonMode="StrongWildcard" maxBufferPoolSize="524288" maxReceivedMessageSize="200000000" messageEncoding="Text" textEncoding="utf-8" useDefaultWebProxy="true" allowCookies="false">
-          <readerQuotas maxDepth="32" maxStringContentLength="32000" maxArrayLength="200000000" maxBytesPerRead="4096" maxNameTableCharCount="16384"/>
-          <reliableSession ordered="true" inactivityTimeout="00:10:00" enabled="false"/>
-          <security mode="Message">
-            <transport clientCredentialType="Windows" proxyCredentialType="None" realm=""/>
-            <message clientCredentialType="UserName" negotiateServiceCredential="true" algorithmSuite="Default"/>
-          </security>
-        </binding>
-
-        <binding name="WSHttpBinding_IAdminService" closeTimeout="00:01:00" openTimeout="00:01:00" receiveTimeout="00:10:00" sendTimeout="00:01:00" bypassProxyOnLocal="false" transactionFlow="false" hostNameComparisonMode="StrongWildcard" maxBufferPoolSize="524288" maxReceivedMessageSize="200000000" messageEncoding="Text" textEncoding="utf-8" useDefaultWebProxy="true" allowCookies="false">
-          <readerQuotas maxDepth="32" maxStringContentLength="32000" maxArrayLength="200000000" maxBytesPerRead="4096" maxNameTableCharCount="16384"/>
-          <reliableSession ordered="true" inactivityTimeout="00:10:00" enabled="false"/>
-          <security mode="Message">
-            <transport clientCredentialType="Windows" proxyCredentialType="None" realm=""/>
-            <message clientCredentialType="UserName" negotiateServiceCredential="true" algorithmSuite="Default"/>
-          </security>
-        </binding>
-      </wsHttpBinding>
-    </bindings>
-
-    <client>
-      <endpoint address="http://services.heuristiclab.com/Deployment-3.3/UpdateService.svc" binding="wsHttpBinding" bindingConfiguration="WSHttpBinding_IUpdateService" contract="HeuristicLab.PluginInfrastructure.Advanced.DeploymentService.IUpdateService" name="WSHttpBinding_IUpdateService">
-        <identity>
-          <certificate encodedValue="AwAAAAEAAAAUAAAAwK1+2oAmcy/mI2P2QjyiJRh0y60gAAAAAQAAACoCAAAwggImMIIBj6ADAgECAhAIkseQ2EEhgU720qJA61gqMA0GCSqGSIb3DQEBBAUAMCQxIjAgBgNVBAMTGXNlcnZpY2VzLmhldXJpc3RpY2xhYi5jb20wHhcNMTAwNTExMTExNDAyWhcNMzkxMjMxMjM1OTU5WjAkMSIwIAYDVQQDExlzZXJ2aWNlcy5oZXVyaXN0aWNsYWIuY29tMIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCq26Bwmwc7k+4W30qLQ2j+FInEL5BuH6opDY6CSlrtt3xQS/anrhvpbf3QghLDVINzcHkzbPmm/SguG4F85QLB6xO+tJaOvRo0iEK5g3c307vMIru7FJwk/OhplEQ5J1hbDgL3zOJlrWlgtqRVxCtVdF3XroI9BctOt1NkeKv9ewIDAQABo1kwVzBVBgNVHQEETjBMgBCjbgdYd4j5JgUuJ1Wo/GxroSYwJDEiMCAGA1UEAxMZc2VydmljZXMuaGV1cmlzdGljbGFiLmNvbYIQCJLHkNhBIYFO9tKiQOtYKjANBgkqhkiG9w0BAQQFAAOBgQAb/2xk2uQad68shSPl/uixWgvFI8WkxOTBopOLaLtDxwCeZ3mWVHdV9VnixHtThubnEBXAhYOCQSIXWtQuXFWO+gH3YyjTRJY5kTmXyuvBRTn3/so5SrQ7Rdlm9hf6E5YVX3tCjAy7ybUyaDUkQfmH5vmvgvpMzRfsJ1qhnUpJiQ=="/>
-        </identity>
-      </endpoint>
-      <endpoint address="http://services.heuristiclab.com/Deployment-3.3/AdminService.svc" binding="wsHttpBinding" bindingConfiguration="WSHttpBinding_IAdminService" contract="HeuristicLab.PluginInfrastructure.Advanced.DeploymentService.IAdminService" name="WSHttpBinding_IAdminService">
-        <identity>
-          <certificate encodedValue="AwAAAAEAAAAUAAAAwK1+2oAmcy/mI2P2QjyiJRh0y60gAAAAAQAAACoCAAAwggImMIIBj6ADAgECAhAIkseQ2EEhgU720qJA61gqMA0GCSqGSIb3DQEBBAUAMCQxIjAgBgNVBAMTGXNlcnZpY2VzLmhldXJpc3RpY2xhYi5jb20wHhcNMTAwNTExMTExNDAyWhcNMzkxMjMxMjM1OTU5WjAkMSIwIAYDVQQDExlzZXJ2aWNlcy5oZXVyaXN0aWNsYWIuY29tMIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCq26Bwmwc7k+4W30qLQ2j+FInEL5BuH6opDY6CSlrtt3xQS/anrhvpbf3QghLDVINzcHkzbPmm/SguG4F85QLB6xO+tJaOvRo0iEK5g3c307vMIru7FJwk/OhplEQ5J1hbDgL3zOJlrWlgtqRVxCtVdF3XroI9BctOt1NkeKv9ewIDAQABo1kwVzBVBgNVHQEETjBMgBCjbgdYd4j5JgUuJ1Wo/GxroSYwJDEiMCAGA1UEAxMZc2VydmljZXMuaGV1cmlzdGljbGFiLmNvbYIQCJLHkNhBIYFO9tKiQOtYKjANBgkqhkiG9w0BAQQFAAOBgQAb/2xk2uQad68shSPl/uixWgvFI8WkxOTBopOLaLtDxwCeZ3mWVHdV9VnixHtThubnEBXAhYOCQSIXWtQuXFWO+gH3YyjTRJY5kTmXyuvBRTn3/so5SrQ7Rdlm9hf6E5YVX3tCjAy7ybUyaDUkQfmH5vmvgvpMzRfsJ1qhnUpJiQ=="/>
-        </identity>
-      </endpoint>
-    </client>
-  </system.serviceModel>
-<startup><supportedRuntime version="v4.0" sku=".NETFramework,Version=v4.5"/></startup></configuration>
+  <startup>
+    <supportedRuntime version="v4.0" sku=".NETFramework,Version=v4.5"/>
+  </startup>
+</configuration>